/*
 *	fram.c
 *
 *	GIFr[A
 *
 *	* Sun Apr 12 20:48:20 JST 2009 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

void
size_proc(int w, int h, void* user_data)
{
	DECODE_PARAM* dp = user_data;
	int scale_w;
	int scale_h;
	scale_w = w * dp->scale_mul / dp->scale_div;
	scale_h = h * dp->scale_mul / dp->scale_div;
	if(scale_w > DISP_X) {
		dp->scale_mul = DISP_X;
		dp->scale_div = w;
	}
	scale_w = w * dp->scale_mul / dp->scale_div;
	scale_h = h * dp->scale_mul / dp->scale_div;
	if(scale_h > DISP_Y) {
		dp->scale_mul = DISP_Y;
		dp->scale_div = h;
	}
	scale_w = w * dp->scale_mul / dp->scale_div;
	scale_h = h * dp->scale_mul / dp->scale_div;
	dp->org_x = (DISP_X - scale_w) / 2;
	dp->org_y = (DISP_Y - scale_h) / 2;
}

void
draw_proc(int i, int x, int y, int c, const unsigned char (*p)[3], void* user_data)
{
	DECODE_PARAM* dp = user_data;
	if(i == 0) {
		x = (x * dp->scale_mul / dp->scale_div) + dp->org_x;
		y = (y * dp->scale_mul / dp->scale_div) + dp->org_y;
		bbuff[y][x] += (p[c][0] * 30 + p[c][1] * 59 + p[c][2] * 11) / 100;
		cbuff[y][x] += 1;
	}
	if(decode_timeout) {
		event_wait(decode_event);
	}
}

void
buff_disp()
{
	static const unsigned char DITHER4[4][4] = {
		{  0, 8, 2,10 },
		{ 12, 4,14, 6 },
		{  3,11, 1, 9 },
		{ 15, 7,13, 5 },
	};
	unsigned short* pb = &bbuff[0][0];
	unsigned char* pc = &cbuff[0][0];
	unsigned char* pv = &vbuff[0];
	int x;
	int y;
	int b;
	int c;
	for(y = 0; y < DISP_Y; y++) {
		for(x = 0; x < DISP_X; x++) {
			b = *pb++;
			c = *pc++;
			if(c) {
				b /= c;
			} else {
				b = (((x + now) ^ (y - now)) & 8) ? 85 : 170;
			}
			b = (b + DITHER4[y & 3][x & 3]) / 16;
			if(b > 15) {
				b = 15;
			}
			*pv++ = b ^ 15;
		}
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

#include "..\clip\clipgif.c"

